diff --git a/src/lib/sixel.c b/src/lib/sixel.c
index 2c929cb798..627d978698 100644
--- a/src/lib/sixel.c
+++ b/src/lib/sixel.c
@@ -141,15 +141,10 @@ initialize_stable(sixeltable* stab){
 // progressively mask more out until they all fit.
 static int
 extract_color_table(const uint32_t* data, int linesize, int begy, int begx,
-                    int leny, int lenx, sixeltable* stab, unsigned char* mask){
-  *mask = 0xf0;
-  while(mask){
-    initialize_stable(stab);
-    if(extract_ctable_inner(data, linesize, begy, begx, leny, lenx, stab, *mask) == 0){
-      return 0;
-    }
-    *mask <<= 1;
-    *mask &= 0xff;
+                    int leny, int lenx, sixeltable* stab){
+  initialize_stable(stab);
+  if(extract_ctable_inner(data, linesize, begy, begx, leny, lenx, stab, 0xf0) == 0){
+    return 0;
   }
   return -1;
 }
@@ -297,8 +292,7 @@ int sixel_blit(ncplane* nc, int placey, int placex, int linesize,
     free(ctab);
     return -1;
   }
-  unsigned char mask;
-  if(extract_color_table(data, linesize, begy, begx, leny, lenx, &stable, &mask)){
+  if(extract_color_table(data, linesize, begy, begx, leny, lenx, &stable)){
     free(ctab);
     free(stable.data);
     free(stable.deets);
